% A generic procedure to invoke ZOM functions and return codes to the ODBC Driver.
% Bressan - 13/08/15 - Disable dependencies and format the error code.
% Bressan - 13/04/16 - Interaction between ZOM and IDE.
procedure pZOMCall(in Action, out ErrCode, out ErrMsg) local(lObjKey, lOK)
   if Action = "IMAGEPATH"
      let ErrCode = "0000"
      let ErrMsg = {$trim($ImagePath), ""}
      return
   endif
   if $position(Action, "DIREMPTY") > 0
      let ErrCode = "0000"
      let ErrMsg = "NO"
      compute 1 ObjectList where DirName = $substring(Action, $position(Action, "=") + 1, 18) \
         evaluate (let ErrMsg = "YES")
      return
   endif
      
   if $position($DirPath(), ";$ZOM(") > 0
      let vZOMDepTrace = $False
      let vZOMError = $null
      let vZOMErrorMsg = ""
   endif
   let <TheAction> = Action
   let $LastErrCode = 0
   let $LastErrMessage = ""
   set output ErrTrace
   set output Terminal

   let lObjKey = $null
   #<TheAction>

   let ErrCode = $mask({$LastErrCode, 0},"9999")
   if $position($DirPath(), ";$ZOM(") > 0
      if vZOMError is not $null
         let ErrCode = vZOMError
         set output ErrTrace append
         out "ZOM Error -" vZOMErrorMsg
         set out terminal
      endif   
   endif
   if lObjKey is not $null
      let ErrMsg = lObjKey
   endif
endprocedure
