%% Updates the version and revision constants in the services development system
%% Main differences with the ones in ZIMBoot* are:
%% 1.) Always updates, even if number is going down.
%% 2.) Doesn't delete the definition.

localprocedure plConstUpdate( vlConstName, \
                              vlDataType, \
                              vlValue, \
                              vlSeq)


   let <ConstName> = $trim( vlConstName ) \
       <DataType> = $trim( vlDataType ) \
       <ConstValue> = $trim( vlValue ) \
       <Seq> = $trim( vlSeq )

   if $exist$( "ZIM", "#<ConstName>", 18 ) = $true
      output "Updating Constant #<ConstName>"
      delete 1 Consts \
         where \
             Consts.ConstName = '#<ConstName>' and \
             Consts.DirName = 'ZIM'
@syser
      erase constant ZIM.#<ConstName> from ZIM
   else
      output "Adding Constant #<ConstName>"
   endif

   add 1 Consts \
      let \
         Consts.ConstName = '#<ConstName>' \
         Consts.DirName = 'ZIM' \
         Consts.ConstType = '#<DataType>' \
         Consts.ConstValue = "#<ConstValue>"

   create constant #<ConstName> in ZIM $sn #<Seq>
   delete 1 Consts \
      where \
          Consts.ConstName = '#<ConstName>' and \
          Consts.DirName = 'ZIM'

endprocedure

plConstUpdate("$DCRevision", "numeric", $CurrentDCRevision, "497" )

