%---------------------------------------------------------------------%
%                         DC_Release
%---------------------------------------------------------------------%
<<
   The purpose of this macro is to provide the possibility
   to release a ZIM directory within DC.

>>
procedure DC_Release (p_dirname, p_ownerdirname) \
      local ( DialogResult )

   if $toupper(p_dirname) in ('ZIM', '_ZIMSERVICES')
      let $abort = $true
      let DialogResult = $MessageBox ( \
         $concat(p_dirname, ' cannot be released.'),\
         cERRORMSG, \
         cOKSTYLE, \
         cDEFAULTBUTTON1, \
         "Directory RELEASE")
      RETURN
   endif

   set save
   set errors off
   let <1> = $trim(p_dirname)

   let $lasterrcode=0
   release #<1>

   if $lasterrcode <> 0
      if $lasterrcode <> 7504
         set errors on
         set warnings on
         DevCenCmdExecute ("RELEASE #<1>")
      endif

      let $abort = $true
      let DialogResult = $MessageBox ( \
         'Release of Directory failed.',\
         cERRORMSG, \
         cOKSTYLE, \
         cDEFAULTBUTTON1, \
         "Directory RELEASE")

   else
      let DialogResult = $MessageBox ( \
         $concat('The Directory ', $trim(p_dirname), \
               ' has been released.'), \
         cINFOMSG, \
         cOKSTYLE, \
         cDEFAULTBUTTON1, \
         "Directory RELEASE")

   endif

   set restore

endprocedure
