%
%   Generate all cross reference data for all user commands
%      using XRProgName (default to zimprof) as the starting point.
%

Procedure   XrefInit2( in XRProgName, in pDocType , inout pResult) \
                   local ( tmpDocName , \
                           DialogResult )

let pResult = $true

delete all XRefObjs

if XRProgName = ''
   let tmpDocName = 'zimprof'
else
   let tmpDocName = XRProgName
endif

find 0 documents ->xrefdocset

if pDocType <> ""
   find documents wh docname = tmpDocName and \
                  doctype = pDocType ->xrefdocset3
else
   find documents wh docname = tmpDocName \
                  and doctype not in ("device") ->xrefdocset3
endif

while
   set output XRefDoc
   set output terminal
   while $setcount > 0
      let <docname> = $trim( docname )
%
      if fXRef.CBConfirm = $true
         let DialogResult = $messagebox ( \
                "Generate XREF for #<docname>?", \
                cQUESTIONMSG, \
                cYESNOCANCELSTYLE, \
                cDEFAULTBUTTON1, \
                "Program Cross Reference")
         if DialogResult = $toalpha("Cancel", 6)
            let pResult = $false
            goto ExitProc
         elseif DialogResult = $toalpha("No", 2)
            goto LoopEnd
         endif
      endif

      set output XRefDoc append
      set xref on
      set errors off
      set warnings off
      parse #<docname>
      set errors on
      set warnings on
      set xref off
      set output terminal

LoopEnd:
      set currentset xrefdocset3
      next xrefdocset3
      let $setcount = $setcount - 1
   endwhile

   add XRefObjs from XRefDoc ->xrefset
   find xrefdocset3 union xrefdocset ->xrefdocset

   %find xrefset XRRefDocs documents \ where documents.doctype = 'program' \
   find xrefset XRRefDocs documents \
      where documents.doctype not in ("device", "data")  \
         keep documents ->xrefdocset2
   find xrefdocset2 minus xrefdocset ->xrefdocset3
   if $setcount = 0
      break
   endif

%   find xrefdocset union xrefdocset3 ->xrefdocset
%   find xrefdocset3 ->xrefdocset3

endwhile

ExitProc:

endprocedure
