%%%   List formfields from a FORM
%%% Author: Livio Taufer
%%% Syntax:
%%%         lsffs [<dirname>.]<formname>[.<fieldname>] [V | P]
%%%      or lsffs <formname>.<fieldname>        list a specific field
%%%      or lsffs <formname> V                  list all VAR type FFS of the form
%%%
%%% Modified March/2111 Livio -
%%%         Accept syntax <dirname>.<formname>
%%%         Accept Roles as <formname>
%%%

if "#<1>" = "?"
   li 8 lsffs
   return
endif

set save
set output trim on
set headings off
set membercount off
set info off
out "#<1> - #<2> - #<3> "
out
if $dirpath() not like "%;$Devcen(%"
   access $devcen
endif
%              Prepare parameters
if "#<1>" <> ""
   let <Filter> = ""
   IF"#<1>" like "%.%.%"
      let <DiName> = $concat(" and Dirname = '",$substring("#<1>",1,$pos("#<1>",".")-1),"'")
      let <1>      =  $substring("#<1>",$pos("#<1>",".")+1,36)
      let <FoName> = $concat("'",$substring("#<1>",1,$pos("#<1>",".")-1),"'")
      let <FiName> = $concat(" and Fieldname = '",$substring("#<1>",$pos("#<1>",".")+1,18),"'")
   elseif "#<1>" like "%.%"
      let <part1> = $substring("#<1>",1,$pos("#<1>",'.')-1)
      compute dirs where dirname = "#<Part1>" eval ""
      if $membercount > 0
         let <DiName> = $concat(" and Dirname = '",$substring("#<1>",1,$pos("#<1>",'.')-1),"'")
         let <FoName> = $concat("'",$substring("#<1>",$pos("#<1>",'.')+1,18),"'")
         let <FiName> = ""
      else
         compute forms where formname= "#<Part1>" eval ""
         if $membercount > 0
            let <DiName> = ""
            let <FoName> = $concat("'",$substring("#<1>",1,$pos("#<1>",'.')-1),"'")
            let <FiName> = $concat(" and Fieldname = '",$substring("#<1>",$pos("#<1>",'.')+1,18),"'")
         else
            out "\0a\0aThe name #<Part1> is not a Directory neither a form."
            set restore
            return
         endif
      endif
   else   %    <1> should be a form
      let <DiName> = ""
      let <FoName> = "#<1>"
      let <FiName> = ""
   ENDIF

   let <filter> = ""
   if "#<2>" > ""
      let <2> = $toupper("#<2>")
      if  "#<2>" in("V","P")           %%% Var or Prompt field type
         let <filter> = " and FT = '#<2>'"
      elseif "#<2>" in("A","N")
         let <filter> = " and DT = '#<2>'"
      endif
   endif
%%%   out "dir: [#<diname>]  form: [#<foname>]   field: #<finame>    --- filter: #<filter> "

   let vObjectOwnerName = NULL   vObjectType = Null
   compute Objlist where ObjectName = "#<FoName>"  eval ((let vObjectType=ObjectType), \
                                                        (let vObjectdirName=dirname))
%%%   out vObjectType vObjectOwnerName vObjectdirName
   if $membercount = 0
      out 'Form "#<FoName>" not found in the Data Dictionary'
   else
     out "Fnum FFSN FieldName           Row  Col Wdth Len  Hght Type DT PM DM   BC FC Defaul"
      list all ffs where FormName = "#<FoName>"  #<DiName> #<FiName> #<filter>  \
          format  \
            $toalpha(FNum,3) \
            $toalpha(FFSN,3) \
            " " fieldname \
            $toalpha(row,4) \
            $toalpha(col,4) \
            $toalpha(Wdth,3) \
            $concat("(",$toalpha(FieldLen,4),")") \
            $toalpha(Hght,3)   \
            $toalpha(WdgType, 3) \
            $toalpha(DT,2) \
            $toalpha(PM,2) \
            $toalpha(DM,4) \
            $toalpha(BC,2) \
            $toalpha(FC,2) \
            $toalpha(Default,20) \
            datamask
   endif
else
   list 7 lsffs
endif
set restore
let <IND> = ""


