%% tZOMCrtBoot

on BREAK
   let vZOMBreak = $true
   RETURN
endon

let <ObjectType> = \
       {$trim(vObjectType) where vObjectType <> 'NamedSet', 'Set'} \
    <ObjectName> = $trim(vObjectName) \
    <ObjectDirName> = $trim(vObjectDirName)

if '#<2>' > ''
   let <9> = $concat(' $fn ', $mask($tonumber('#<2>', 0), '9999'), ' delete')
endif

if vObjectType = DOCOBJTYPE
   %% If this is a Zim Class then derive it's attribute structure name
   %% First check for an explict name
   find 1 Documents DocFields Fields \
      where DocName = vObjectName and Documents.DirName = vObjectDirName \
        and DocType = 'Zim Class' \
        and FieldName = '_ZOFClassStructure'
   let <8> = Fields.Default
   if $setcount = 0 and vObjectName like 'z%'
      %% There is no explicit name defined so build one from the DocName
      find 1 Documents \
         where DocName = vObjectName and DirName = vObjectDirName \
           and DocType = 'Zim Class'
      let <8> = $trim($replace(DocName, 1, 1, 'a'))
   elseif '#<8>' = $replace(vObjectName, 1, 1, 'a')
      %% It follows the naming convention, so we don't need to be explicit
      delete 1 Fields \
         where OwnerName = vObjectName and DirName = vObjectDirName \
           and FieldName = '_ZOFClassStructure'
   endif
   if '#<8>' > ''
      %% Move the attribute fields to the structure
      delete all Fields \
         where OwnerName = '#<8>' and DirName = '#<ObjectDirName>'
      change all Fields \
         where OwnerName = '#<ObjectName>' and DirName = '#<ObjectDirName>' \
         let OwnerName = '#<8>' \
         -> sAttrsFromZOFClass
<<
   %% Move the attribute fields to the structure
   delete all Fields \
      where OwnerName = '#<8>' and DirName = '#<ObjectDirName>'
   change all Fields \
      where OwnerName = '#<ObjectName>' and DirName = '#<ObjectDirName>' \
      let OwnerName = '#<8>' \
      -> sAttrsFromZOFClass
   add 1 Fields \
      let OwnerName = '#<ObjectName>' \
          DirName = '#<ObjectDirName>' \
          FieldName = 'SourceCode' \
          Fields.Type = 'Alpha' \
          Length = 256 \
          SN = 1
>>
   endif
endif
IF vZomOperationMode = "DC" 
<<
   create #<ObjectType> #<ObjectName> in #<ObjectDirName>#<9>
>>
ELSE
<<
   output 'creating #<ObjectType> "#<ObjectName>" in "#<ObjectDirName>"#<9>'
   create #<ObjectType> #<ObjectName> in #<ObjectDirName>#<9>
>>
ENDIF
if '#<8>' > ''
   %% Move these fields back to the document to get them out of the way
   change all sAttrsFromZOFClass \
      where FieldName in ('_ZOFClassStructure', '_IncludeOtherAttrs') \
      let OwnerName = '#<ObjectName>'
<<
   delete 1 Fields \
      where OwnerName = '#<ObjectName>' and DirName = '#<ObjectDirName>' \
        and FieldName = 'SourceCode'
   %% Move these fields back to the document to get them out of the way
   change all sAttrsFromZOFClass \
      where FieldName in ('_ZOFClassStructure', '_IncludeOtherAttrs') \
      let OwnerName = '#<ObjectName>'
>>

   %% Add "base" attributes (until we get the super classes set up)
   compute 1 Fields \
         where OwnerName = '#<8>' and DirName = vObjectDirName \
           and FieldName = 'pMethod' \
      evaluate ('')
   if $membercount = 0
<<
   add 1 Fields \
      let OwnerName = '#<8>' \
          DirName = '#<ObjectDirName>' \
          FieldName = 'pMethod' \
          Fields.Type = 'VarAlpha' \
          Length = 100 \
          SN = 1
>>
   endif
   compute 1 Fields \
         where OwnerName = '#<8>' and DirName = vObjectDirName \
           and FieldName = 'oException' \
      evaluate ('')
   if $membercount = 0
<<
   add 1 Fields \
      let OwnerName = '#<8>' \
          DirName = '#<ObjectDirName>' \
          FieldName = 'oException' \
          Fields.Type = 'VarAlpha' \
          Length = 100 \
          SN = 2
>>
   endif

<<
   add 1 EntitySets \
      let EntName = '#<8>' \
          DirName = '#<ObjectDirName>'
>>
IF vZomOperationMode <> "DC" 
<<
   output 'creating Form Entity "#<8>" in "#<ObjectDirName>"'
>>
ENDIF
<<
   create Form Entity #<8> in #<ObjectDirName>
>>

   %% Move the fields that came from the document back to the document
   change all sAttrsFromZOFClass \
      let OwnerName = '#<ObjectName>'
   %% Just delete the "included" fields
   delete all Fields \
      where OwnerName = '#<8>' and DirName = '#<ObjectDirName>'
<<
   delete 1 EntitySets \
      where EntName = '#<8>' and DirName = '#<ObjectDirName>'
   %% Move the fields that came from the document back to the document
   change all sAttrsFromZOFClass \
      let OwnerName = '#<ObjectName>'
   %% Just delete the included fields
   delete all Fields \
      where OwnerName = '#<8>' and DirName = '#<ObjectDirName>'
>>
endif

let vobjectname='#<ObjectName>'

if vZOMDataSaveAble = 'Y' and vObjectType in (ENTOBJTYPE, RELOBJTYPE) and $substring($tolower(vObjectName),1,2) <> "sh"
<<
   set DataBase Access Exclusive
   set escapechar off
   if $ZimOS = 11
      system $concat("!copy ", $trim($filepath(#<ObjectDirName>.#<ObjectName>)), " ", $trim($filepath(#<ObjectDirName>.#<ObjectName>)), ".0") invisible remote
   else
      system $concat("cp ", $trim($filepath(#<ObjectDirName>.#<ObjectName>)), " ", $trim($filepath(#<ObjectDirName>.#<ObjectName>)), ".0") invisible remote
   endif
   set escapechar on
   set DataBase Access Shared

>>
elseif vObjectType = DIROBJTYPE
<<
   access #<ObjectName> update
>>
else
<<
>>
endif
RETURN
