%% tZOMDispDDBoot

on BREAK
   let vZOMBreak = $true
   RETURN
endon

find 1 Displays \
   where Displays.ObjectKey = vObjectKey

let \
   <UniqueName> = \
      {$concat('"', $trim(Displays.UniqueDispDirName), '"'), '$null'} \
   <DisplayName> = {$concat('"', $trim(Displays.DisplayName), '"'), '$null'} \
   <DirName> = {$concat('"', $trim(Displays.DirName), '"'), '$null'} \
   <WdgTag> = {$concat('"', $trim(Displays.WdgTag), '"'), '$null'} \
   <HMargin> = {$concat('"', $trim(Displays.HMargin), '"'), '$null'} \
   <VMargin> = {$concat('"', $trim(Displays.VMargin), '"'), '$null'} \
   <WdgHMargin> = {$concat('"', $trim(Displays.WdgHMargin), '"'), '$null'} \
   <WdgVMargin> = {$concat('"', $trim(Displays.WdgVMargin), '"'), '$null'} \
   <WdgWdth> = {$concat('"', $trim(Displays.WdgWdth), '"'), '$null'} \
   <WdgHght> = {$concat('"', $trim(Displays.WdgHght), '"'), '$null'} \
   <Wdth> = {$concat('"', $trim(Displays.WdgWdth), '"'), '$null'} \
   <Hght> = {$concat('"', $trim(Displays.WdgWdth), '"'), '$null'} \
   <ObjectKey> = {$concat('"', vObjectKey, '"') \
      where vZOMOptions[ZOMOOPTION] is not $null, '$null'}

if vZOMOptions[ZOMUOPTION] is not $null
   let <BootAction> = 'Updating'
<<
   delete all Displays DispDispForms DisplayForms \
      where UniqueDispDirName = #<UniqueName> \
      keep DisplayForms
   delete Displays \
      where UniqueDispDirName = #<UniqueName>
>>
else
   let <BootAction> = 'Adding'
endif

<<
   set escapechar off
   add 1 Displays \
      let \
         Displays.DisplayName = #<DisplayName> \
         Displays.DirName = #<DirName> \
         Displays.WdgTag = #<WdgTag> \
         Displays.HMargin = #<HMargin> \
         Displays.VMargin = #<VMargin> \
         Displays.WdgHMargin = #<WdgHMargin> \
         Displays.WdgVMargin = #<WdgVMargin> \
         Displays.WdgWdth = #<WdgWdth> \
         Displays.WdgHght = #<WdgHght> \
         Displays.Wdth = #<Wdth> \
         Displays.Hght = #<Hght> \
         Displays.ObjectKey = #<ObjectKey>

>>

find all Displays DispDispForms DisplayForms \
  where Displays.ObjectKey = vObjectKey \
keep DisplayForms

while $setcount > 0
   let \
      <DisplayName> = \
         {$concat('"', $trim(DisplayForms.DisplayName), '"'), '$null'} \
      <FormName> = {$concat('"', $trim(DisplayForms.FormName), '"'), '$null'} \
      <FormNum> = {$concat('"', $trim(DisplayForms.FormNum), '"'), '$null'} \
      <FSN> = {$concat('"', $trim(DisplayForms.FSN), '"'), '$null'} \
      <Row> = {$concat('"', $trim(DisplayForms.Row), '"'), '$null'} \
      <Col> = {$concat('"', $trim(DisplayForms.Col), '"'), '$null'} \
      <LoadOrder> = \
         {$concat('"', $trim(DisplayForms.LoadOrder), '"'), '$null'} \
      <RD> = {$concat('"', $trim(DisplayForms.RD), '"'), '$null'} \
      <RA> = {$concat('"', $trim(DisplayForms.RA), '"'), '$null'} \
      <FormDirName> = \
         {$concat('"', $trim(DisplayForms.FormDirName), '"'), '$null'} \
      <DirName> = {$concat('"', $trim(DisplayForms.DirName), '"'), '$null'} \
      <WdgRow> = {$concat('"', $trim(DisplayForms.WdgRow), '"'), '$null'} \
      <WdgCol> = {$concat('"', $trim(DisplayForms.WdgCol), '"'), '$null'} \
      <HMargin> = {$concat('"', $trim(DisplayForms.HMargin), '"'), '$null'} \
      <VMargin> = {$concat('"', $trim(DisplayForms.VMargin), '"'), '$null'} \
      <WdgHMargin> = \
         {$concat('"', $trim(DisplayForms.WdgHMargin), '"'), '$null'} \
      <WdgVMargin> = \
         {$concat('"', $trim(DisplayForms.WdgVMargin), '"'), '$null'} \
      <WdgWdth> = {$concat('"', $trim(DisplayForms.WdgWdth), '"'), '$null'} \
      <WdgHght> = {$concat('"', $trim(DisplayForms.WdgHght), '"'), '$null'} \
      <Wdth> = {$concat('"', $trim(DisplayForms.Wdth), '"'), '$null'} \
      <Hght> = {$concat('"', $trim(DisplayForms.Hght), '"'), '$null'} \
      <WdgZOrder> = \
         {$concat('"', $trim(DisplayForms.WdgZOrder), '"'), '$null'} \
      <ObjectKey> = {$concat('"', $trim(DisplayForms.ObjectKey), '"') \
         where vZOMOptions[ZOMOOPTION] is not $null, '$null'}

<<
   add 1 DisplayForms \
      let \
         DisplayForms.DisplayName = #<DisplayName> \
         DisplayForms.FormName = #<FormName> \
         DisplayForms.FormNum = #<FormNum> \
         DisplayForms.FSN = #<FSN> \
         DisplayForms.Row = #<Row> \
         DisplayForms.Col = #<Col> \
         DisplayForms.LoadOrder = #<LoadOrder> \
         DisplayForms.RD = #<RD> \
         DisplayForms.RA = #<RA> \
         DisplayForms.FormDirName = #<FormDirName> \
         DisplayForms.DirName = #<DirName> \
         DisplayForms.WdgRow = #<WdgRow> \
         DisplayForms.WdgCol = #<WdgCol> \
         DisplayForms.HMargin = #<HMargin> \
         DisplayForms.VMargin = #<VMargin> \
         DisplayForms.WdgHMargin = #<WdgHMargin> \
         DisplayForms.WdgVMargin = #<WdgVMargin> \
         DisplayForms.WdgWdth = #<WdgWdth> \
         DisplayForms.WdgHght = #<WdgHght> \
         DisplayForms.Wdth = #<Wdth> \
         DisplayForms.Hght = #<Hght> \
         DisplayForms.WdgZOrder = #<WdgZOrder> \
         DisplayForms.ObjectKey = #<ObjectKey>

>>
   let $setcount = $setcount - 1
   next
endwhile

<<
   set escapechar on

>>
