%% tZOMObjectBoot

on BREAK
   let vZOMBreak = $true
   RETURN
endon

find 1 ObjectList \
   where ObjectKey = vObjectKey

let \
   <ObjectName> = {$concat('"', $trim(ObjectList.ObjectName), '"'), '$null'} \
   <DirName> = {$concat('"', $trim(ObjectList.DirName), '"'), '$null'} \
   <OwnerName> = {$concat('"', $trim(ObjectList.OwnerName), '"'), '$null'} \
   <ObjectType> = {$concat('"', $trim(ObjectList.ObjectType), '"'), '$null'} \
   <ObjectKey> = {$concat('"', $trim(ObjectList.ObjectKey), '"'), '$null'} \
   <NotExist> = {$concat('"', $trim(ObjectList.NotExist), '"'), '$null'} \
   <ToProcess> = {$concat('"', $trim(ObjectList.ToProcess), '"'), '$null'} \
   <DependencyLevel> = \
      {$concat('"', $trim(ObjectList.DependencyLevel), '"'), '$null'} \
   <ProcessErrors> = \
      {$concat('"', $trim(ObjectList.ProcessErrors), '"'), '$null'} \
   <NotDefined> = {$concat('"', $trim(ObjectList.NotDefined), '"'), '$null'} \
   <NotActive> = {$concat('"', $trim(ObjectList.NotActive), '"'), '$null'} \
   <CompileAble> = {$concat('"', $trim(ObjectList.CompileAble), '"'), '$null'} \
   <CompileError> = \
      {$concat('"', $trim(ObjectList.CompileError), '"'), '$null'} \
   <CompileStatus> = \
      {$concat('"', $trim(ObjectList.CompileStatus), '"'), '$null'} \
   <Locked> = {$concat('"', $trim(ObjectList.Locked), '"'), '$null'} \
   <AutoDataSave> = \
      {$concat('"', $trim(ObjectList.AutoDataSave), '"'), '$null'} \
   <DataSaveAble> = \
      {$concat('"', $trim(ObjectList.DataSaveAble), '"'), '$null'} \
   <Selected> = {$concat('"', $trim(ObjectList.Selected), '"'), '$null'} \
   <ReNamed> = {$concat('"', $trim(ObjectList.ReNamed), '"'), '$null'} \
   <Changed> = {$concat('"', $trim(ObjectList.Changed), '"'), '$null'} \
   <Moved> = {$concat('"', $trim(ObjectList.Moved), '"'), '$null'} \
   <NewObject> = {$concat('"', $trim(ObjectList.NewObject), '"'), '$null'} \
   <FileNumber> = {$concat('"', $trim(ObjectList.FileNumber), '"'), '$null'} \
   <SysSeqNo> = {$concat('"', $trim(ObjectList.SysSeqNo), '"'), '$null'} \
   <TmpCounter1> = {$concat('"', $trim(ObjectList.TmpCounter1), '"'), '$null'} \
   <TmpCounter2> = {$concat('"', $trim(ObjectList.TmpCounter2), '"'), '$null'} \
   <TmpCounter3> = {$concat('"', $trim(ObjectList.TmpCounter3), '"'), '$null'}

if vZOMOptions[ZOMUOPTION] is not $null
<<
   delete 1 ObjectList \
      where ObjectKey = #<ObjectKey>
   delete all DDDescriptions \
      where ObjectKey = #<ObjectKey>
   delete all Keywords \
      where ObjectKey = #<ObjectKey>
>>
endif
<<
   set escapechar off
   add 1 ObjectList \
      let \
         ObjectList.ObjectName = #<ObjectName> \
         ObjectList.DirName = #<DirName> \
         ObjectList.OwnerName = #<OwnerName> \
         ObjectList.ObjectType = #<ObjectType> \
         ObjectList.ObjectKey = #<ObjectKey> \
         ObjectList.NotExist = #<NotExist> \
         ObjectList.ToProcess = #<ToProcess> \
         ObjectList.DependencyLevel = #<DependencyLevel> \
         ObjectList.ProcessErrors = #<ProcessErrors> \
         ObjectList.NotDefined = #<NotDefined> \
         ObjectList.NotActive = #<NotActive> \
         ObjectList.CompileAble = #<CompileAble> \
         ObjectList.CompileError = #<CompileError> \
         ObjectList.CompileStatus = #<CompileStatus> \
         ObjectList.Locked = #<Locked> \
         ObjectList.AutoDataSave = #<AutoDataSave> \
         ObjectList.DataSaveAble = #<DataSaveAble> \
         ObjectList.Selected = #<Selected> \
         ObjectList.ReNamed = #<ReNamed> \
         ObjectList.Changed = #<Changed> \
         ObjectList.Moved = #<Moved> \
         ObjectList.NewObject = #<NewObject> \
         ObjectList.FileNumber = #<FileNumber> \
         ObjectList.SysSeqNo = #<SysSeqNo> \
         ObjectList.TmpCounter1 = #<TmpCounter1> \
         ObjectList.TmpCounter2 = #<TmpCounter2> \
         ObjectList.TmpCounter3 = #<TmpCounter3>

>>

find all Keywords \
   where ObjectKey = vObjectKey

while $setcount > 0
   let <Keyword> = {$concat('"', $trim(Keywords.Keyword), '"'), '$null'}

<<
   add 1 Keywords \
      let \
         Keywords.Keyword = #<Keyword> \
         Keywords.ObjectKey = #<ObjectKey>
>>
   let $setcount = $setcount - 1
   next
endwhile

find all DDDescriptions \
   where ObjectKey = vObjectKey

while $setcount > 0
   let \
      <DDObjectDesc> = \
         {$concat('"', $trim(DDDescriptions.DDObjectDesc), '"'), '$null'} \
      <DDObjectName> = \
         {$concat('"', $trim(DDDescriptions.DDObjectName), '"'), '$null'} \
      <DDObjectType> = \
         {$concat('"', $trim(DDDescriptions.DDObjectType), '"'), '$null'} \
      <DDOwnerName> = \
         {$concat('"', $trim(DDDescriptions.DDOwnerName), '"'), '$null'} \
      <DirName> = {$concat('"', $trim(DDDescriptions.DirName), '"'), '$null'}

<<
   add 1 DDDescriptions \
      let \
         DDDescriptions.DDObjectDesc = #<DDObjectDesc> \
         DDDescriptions.DDObjectName = #<DDObjectName> \
         DDDescriptions.DDObjectType = #<DDObjectType> \
         DDDescriptions.DDOwnerName = #<DDOwnerName> \
         DDDescriptions.DirName = #<DirName> \
         DDDescriptions.ObjectKey = #<ObjectKey>
>>
   let $setcount = $setcount - 1
   next
endwhile

find all ObjectList ObjList2PtrGrps PainterGroups \
   where ObjectKey = vObjectKey

while $setcount > 0
   let \
      <WinName> = {$concat('"', $trim(PainterGroups.WinName), '"'), '$null'} \
      <WinDirName> = \
         {$concat('"', $trim(PainterGroups.WinDirName), '"'), '$null'} \
      <FDName> = {$concat('"', $trim(PainterGroups.FDName), '"'), '$null'} \
      <FDDirName> = \
         {$concat('"', $trim(PainterGroups.FDDirName), '"'), '$null'} \
      <MenuName> = {$concat('"', $trim(PainterGroups.MenuName), '"'), '$null'} \
      <MenuDirName> = \
         {$concat('"', $trim(PainterGroups.MenuDirName), '"'), '$null'}

<<
   add 1 PainterGroups \
      let \
         PainterGroups.WinName = #<WinName> \
         PainterGroups.WinDirName = #<WinDirName> \
         PainterGroups.FDName = #<FDName> \
         PainterGroups.FDDirName = #<FDDirName> \
         PainterGroups.MenuName = #<MenuName> \
         PainterGroups.MenuDirName = #<MenuDirName>
>>
   let $setcount = $setcount - 1
   next
endwhile

<<
   set escapechar on

>>
