on BREAK
   set output errtrace append
   output '---- ZOM touch of #<ObjDirName>.#<ObjectName> interrupted. ----'
   let vZOMBreak = $true
   SET RESTORE
   RETURN
endon

SET SAVE
set messages off

let vObjectExists = $null \
    vObjectCorrupt = $null \
    vObjectSysSeqNo = $null \
    vObjectFileNumber = $null \
    vObjectCompileErr = $null \
    vObjectCompileStat = $null \
    $LastErrCode = $null \
    <ObjectType> = $trim(vObjectType) \
    <ObjectKey> = $trim(vObjectKey) \
    <ObjectName> = $trim(vObjectName) \
    <ObjOwnerName> = $trim(vObjectOwnerName) \
    <ObjDirName> = $trim(vObjectDirName) \
    <ObjExistNum> = { \
       2 where vObjectType  = DIROBJTYPE, \
       4 where vObjectType  = ENTOBJTYPE, \
       6 where vObjectType  = RELOBJTYPE, \
       8 where vObjectType  = SETOBJTYPE, \
       9 where vObjectType  = DOCOBJTYPE, \
       11 where vObjectType = FORMOBJTYPE, \
       12 where vObjectType = ROLEOBJTYPE, \
       13 where vObjectType = VAROBJTYPE, \
       14 where vObjectType = DISPOBJTYPE, \
       17 where vObjectType = WINOBJTYPE, \
       18 where vObjectType = CONSTOBJTYPE, \
       19 where vObjectType = MENUOBJTYPE}

if vZOMErrorLog = $true
   set output errtrace append
   let <9> = ': Ignore enclosed warnings.' where vObjectCompileable = 'I'
   output '---- ZOM touching #<ObjDirName>.#<ObjectName>#<9> ----'
   set output terminal
endif

if vObjectName = 'ZIM'
   let vObjectExists = $true \
       vObjectSysSeqNo = $sysseqno(ZIM) \
       vObjectFileNumber = $filenum(ZIM) \
       vObjectCompileErr = $false \
       vObjectCompileStat = $null
   set output dsDependencies
   dependency ZIM
   set output terminal
else
   if $dirpath() not like '%;#<ObjDirName>(R);%' and $dirpath() not like '%#<objdirname>(U);%'
       access #<ObjDirName> read
   endif

   let vObjectExists = {$true where $exist$('#<ObjDirName>', '#<ObjectName>', #<ObjExistNum>) = $true, $false}
%%%        vObjectExists will never be NULL. It was set to $TRUE or $FALSE on the previous command  - Livio 06-Jun-17
%%%   if vObjectExists is $null and vObjectType = RELOBJTYPE
   if vObjectExists = $False and vObjectType = RELOBJTYPE
      let vObjectExists = {$true where $exist$('#<ObjDirName>', '#<ObjectName>', 7) = $true, $false} %%% Test for DATAREL?
   endif

   % The owner of the role must be there too.
   if vObjectType = ROLEOBJTYPE and vObjectCorrupt is $null
      let $lasterrcode = $null
      if $exist$("#<ObjDirName>", "#<ObjOwnerName>", 4) = $false and $exist$("#<ObjDirName>", "#<ObjOwnerName>", 7) = $false
         %% The object for which <ObjectName> is a role name has been erased.
         let vObjectCorrupt = 7 \
             $lasterrcode = $null
      endif
   endif
   if vObjectCorrupt = 7
      let vObjectExists = $true \
          vObjectCorrupt = $true
   else
      let vObjectCorrupt = $null
   endif
   if vObjectExists = $true
      let vObjectSysSeqNo = $sysseqno(#<ObjDirName>.#<ObjectName>)
      if vObjectType = DOCOBJTYPE

         let vObjectCompileStat = $compilestatus(#<ObjDirName>.#<ObjectName>)
         if $value(vObjectCompileAble," ") in ('Y', 'I', 'M')
            if vZOMCompileSet is $null % we didn't just compile
               set output dsDependencies % to catch any spurious output
               if $value(vObjectCompileAble," ") = 'M'                                 %%% If the document is a macro
                  let <EE> = $getproperty("session","error trace")         %%% Do not write errors to the errors trace
                  let <Result> = $setproperty("session","error trace",'no')
                  parse #<ObjDirName>.#<ObjectName>
                  let <Result> = $setproperty("session","error trace",'#<EE>')   %%% restore the errors output
               else
                  parse #<ObjDirName>.#<ObjectName>
               endif
               let vObjectCompileErr = \
                      {$false where vObjectCompileAble = 'M', \
                       $true where $LastErrCode is not $null \
                               and vObjectCompileAble = 'Y', \
                       $true where $LastErrLevel > 2 \
                               and vObjectCompileable = 'I', \
                       $false} \
                   vObjectCompileStat = \
                      $compilestatus(#<ObjDirName>.#<ObjectName>)
            endif
         else
            let vObjectCompileErr = $false
         endif
      elseif vZOMDataSaveAble = 'Y' or vObjectType = DIROBJTYPE
         let vObjectFileNumber = $filenum(#<ObjDirName>.#<ObjectName>) \
             vObjectCompileErr = $false \
             vObjectCompileStat = $null
      else
         let vObjectCompileErr = $false \
             vObjectCompileStat = $null
      endif
      set output dsDependencies
      if vObjectType = FLDOBJTYPE
         dependency #<ObjDirName>.#<ObjOwnerName>.#<ObjectName>
      else
         dependency #<ObjDirName>.#<ObjectName>
      endif
      set output terminal
   endif
endif

%%%%release #<objdirname>

SET RESTORE
