%% tZOMInit

ON BREAK
   LET vZOMBreak = $TRUE
   SET ESCAPECHAR ON
   RETURN
ENDON

SET ESCAPECHAR OFF

%% Assign values and/or set defaults
LET <ZIMPath> =      $TRIM($zimpath) \
    <DBPath> =       $TRIM($dbpath) \
    <WorkPath> =     $TRIM($workpath) \
    <ZOMInstanceID> = $TRIM(vZOMInstanceID) \
    <OutputDoc> =    '#<1>' \
    <GenerationDate> = $CONCAT($MASK($DATE, 'DD'), $MASK($MONTHNAME($DATE), '-???-'), $MASK($DATE, 'YY')) \
    <GenerationTime> = $MASK($TIME, '??:??:??.??') \
    <DCRevision> =   $TRIM($DCRevision)

LET <Section> = 'INI:[ZOM for #<ZOMInstanceID>]'
LET <SetProperty> = $setproperty('#<Section>', 'Conventions On', {$false WHERE vZOMConventionsOn = $FALSE, $true}) \
    <SetProperty> = $setproperty('#<Section>', 'Changed Keyword', {$TRIM(vZOMChgKeyword) WHERE vZOMChgKeyword > '', '$Changed'}) \
    <SetProperty> = $setproperty('#<Section>', 'Default ZIM Directory', {$TRIM(vZOMDefaultDir) WHERE vZOMDefaultDir > '', 'ZIM'}) \
    <SetProperty> = $setproperty('#<Section>', 'Default Data Save Folder', {$TRIM(vZOMDefSaveFolder) WHERE vZOMDefSaveFolder > '', '"/zomsaving'}) \
    <SetProperty> = $setproperty('#<Section>', 'Dependency Trace', {$false WHERE vZOMDepTrace = $FALSE, $true}) \
    <SetProperty> = $setproperty('#<Section>', 'Display Mode', {vZOMDisplay WHERE vZOMDisplay IN ('W', 'N'), 'S'}) \
    <SetProperty> = $setproperty('#<Section>', 'Explode Level', {$TRIM(vZOMExplodeLevel) WHERE vZOMExplodeLevel BETWEEN '0' AND '2','1'}) \
    <SetProperty> = $setproperty('#<Section>', 'Express Mode', {$false WHERE vZOMTurbo = $FALSE, $true}) \
    <SetProperty> = $setproperty('#<Section>', 'Log Errors', {$false WHERE vZOMErrorLog = $FALSE, $true}) \
    <SetProperty> = $setproperty('#<Section>', 'New Keyword', {$TRIM(vZOMNewKeyword) WHERE vZOMNewKeyword > '', '$New'}) \
    <SetProperty> = $setproperty('#<Section>', 'Sort Order', {$TRIM(vZOMSortOrder) WHERE vZOMSortOrder > '', ''}) \
    <SetProperty> = $setproperty('#<Section>', 'Database Directory',$TRIM($DbPath)) \
    <SetProperty> = $setproperty('#<Section>', 'Date Create',$tochar($date,8))

%           ObjectDataSaveDir should always be the original object directory (LAT -8/2016)
%    <SetProperty> = $setproperty('#<Section>', 'Object Data Save Directory', {$TRIM(vObjectDataSaveDir) WHERE vObjectDataSaveDir > '', 'ZIM'}) 

<<
%% Generated by ZOMConfig
%% Generation date              #<GenerationDate>
%% Generation time              #<GenerationTime>
%% Development Centre Revision  #<DCRevision>

procedure #<OutputDoc>() \
      local (vlStatus, vlAction, vlWindowName)

   SET SAVE
   set reset
   set messages off

>>
%% N.B. The following LET statements should not be combined into one LET
%%      statement. This will prevent cascading errors in the future if a
%%      variable name changes.
<<
   let vZOMInstanceID     = '#<ZOMInstanceID>'
   let vZOMChgKeyword     = {$getproperty('#<Section>', 'Changed Keyword'), '$Changed'}
   let vZOMConventionsOn  = {$getproperty('#<Section>', 'Conventions On'), $true}
   let vZOMDefaultDir     = {$getproperty('#<Section>', 'Default ZIM Directory'), 'ZIM'}
   LET vZOMDefSaveFolder  = {$getproperty('#<Section>', 'Default Data Save Folder'),'"/zomsaving'}
   let vZOMDepTrace       = {$getproperty('#<Section>', 'Dependency Trace'), $true}
   let vZOMDisplay        = {$getproperty('#<Section>', 'Display Mode'), 'S'}
   let vZOMErrorLog       = {$getproperty('#<Section>', 'Log Errors'), $true}
   let vZOMExplodeLevel   = {$getproperty('#<Section>', 'Explode Level'), '1'}
   let vZOMTurbo          = {$getproperty('#<Section>', 'Express Mode'), $true}
   let vZOMNewKeyword     = {$getproperty('#<Section>', 'New Keyword'), '$New'}
   let vZOMSortOrder      = {$getproperty('#<Section>', 'Sort Order'), ''}
%           ObjectDataSaveDir should always be the original object directory (LAT -8/2016)
%   let vObjectDataSaveDir = {$getproperty('#<Section>', 'Object Data Save Directory'), 'ZIM'}

   if NOT vZOMType = ""
      SET RESTORE
      RETURN
   endif
   set escapechar on

   SET RESTORE
endprocedure

>>

SET ESCAPECHAR ON
